## appstream 0.8.4

=== CMakeLists.txt ===
# CMakeLists for the AppStream Project
project(appstream)
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

set(CMAKE_BUILD_TYPE "Debug")

set(AS_VERSION_MAJOR  "0")
set(AS_VERSION_MINOR  "8")
set(AS_VERSION_PATCH  "4")
set(AS_VERSION "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}.${AS_VERSION_PATCH}")
set(APPSTREAM_LIB_API_LEVEL "2")

# Don't allow in-tree building
if(${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})
      message(STATUS "Please do an out-of-tree build:")
      message(STATUS "rm -f CMakeCache.txt && mkdir build && cd build; cmake .. && make")
      message(FATAL_ERROR "In-tree-build detected!")
endif(${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})

#
# Options
#
option(DEBIAN_DEP11 "Enable DEP11 data provider" ON)
option(L18N "Enable localization" ON)
option(VAPI "Create and install a Vala API file" OFF)
option(QT "Build libappstream-qt" OFF)
option(TESTS "Enable Unit Tests" OFF)
option(MAINTAINER "Enable maintainer mode" OFF)
option(DOCUMENTATION "Enable target to build documentation" OFF)

if(DEBIAN_DEP11)
	add_definitions ("-DDEBIAN_DEP11")
endif()

#
# Default paths
#
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX
    "/usr" CACHE PATH "Default install prefix" FORCE)
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

# Special case for /etc and /var when prefix is /usr
if(${CMAKE_INSTALL_PREFIX} STREQUAL "/usr")
  set(CMAKE_INSTALL_SYSCONFDIR "/etc" CACHE PATH "read-only single-machine data (etc)")
  set(CMAKE_INSTALL_LOCALSTATEDIR "/var" CACHE PATH "modifiable single-machine data (var)")
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/usr")
include(GNUInstallDirs)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/data/cmake/)

message(STATUS "Compiling AppStream version ${AS_VERSION}")

add_custom_target(distclean
  "make clean"
)

#
# l18n
#
find_package (Gettext REQUIRED)

#
# Configure files
#
set (GETTEXT_PACKAGE "appstream")
set (VERSION "${AS_VERSION}")
configure_file(config.h.in ${CMAKE_BINARY_DIR}/config.h)

#
# Enable/disable testing
#
if(TESTS)
	enable_testing()
endif(TESTS)

#
# Custom C flags
#
set(MAINTAINER_CFLAGS "")
if(MAINTAINER)
	set(MAINTAINER_CFLAGS "-Werror -Wall -Wcast-align -Wno-uninitialized -Wempty-body -Wformat-security -Winit-self")
	if (CMAKE_COMPILER_IS_GNUCC)
		execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                OUTPUT_VARIABLE GCC_VERSION)
		if (GCC_VERSION VERSION_GREATER 4.9 OR GCC_VERSION VERSION_EQUAL 4.9)
			set(MAINTAINER_CFLAGS ${MAINTAINER_CFLAGS} "-fdiagnostics-color=auto")
		endif()
	endif()
endif(MAINTAINER)
add_definitions(${MAINTAINER_CFLAGS})

# we do always enable this to never run into the missing-include-trap again
add_definitions("-Werror=implicit-function-declaration")

find_package(PkgConfig REQUIRED)

add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(contrib)
add_subdirectory(po)
add_subdirectory(docs)
add_subdirectory(tests)
if(QT)
	add_subdirectory(qt)
endif()

=== docs/CMakeLists.txt ===
# CMakeLists for documentation

find_program (XMLTO xmlto)
mark_as_advanced (XMLTO)
if (XMLTO STREQUAL "XMLTO-NOTFOUND")
	message (FATAL_ERROR "Xmlto was not found! Please install it to continue!")
endif (XMLTO STREQUAL "XMLTO-NOTFOUND")

include (${CMAKE_SOURCE_DIR}/data/cmake/documentation.cmake)

add_xml_manpages(doc-man-asi "sources/man/appstreamcli.1" "" "")

set(DOC_HTML_EXPORT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/html")

if (DOCUMENTATION)
	#########################
	# General project documentation
	find_program (PUBLICAN publican)
	mark_as_advanced (PUBLICAN)
	if (PUBLICAN STREQUAL "PUBLICAN-NOTFOUND")
		message (FATAL_ERROR "Publican was not found. Please install it to continue!")
	endif (PUBLICAN STREQUAL "PUBLICAN-NOTFOUND")

	# we need to assemble our documentation build-directory before we can built it
	add_custom_target (assemble-docs
		COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/prepare-docbuild.sh" "source_dir=${CMAKE_CURRENT_SOURCE_DIR}" "build_dir=${CMAKE_BINARY_DIR}/docbuild"
		DEPENDS "publican.cfg"
			"sources/"
			"${CMAKE_BINARY_DIR}/docbuild/"
			appstream
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		VERBATIM
	)

	# the actual target to build all documentation
	add_custom_target (documentation-noexport
		COMMAND ${PUBLICAN} "build" "--langs=en-US" "--publish" "--formats=html"
		DEPENDS "publican.cfg"
			"${CMAKE_BINARY_DIR}/docbuild/publican.cfg"
			assemble-docs
			doc-appstream
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/docbuild/
	)
	add_custom_command (OUTPUT "${CMAKE_BINARY_DIR}/docbuild/"
			COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_BINARY_DIR}/docbuild"
			VERBATIM
	)

	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_CURRENT_SOURCE_DIR}/html)
	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_BINARY_DIR}/docbuild)

	# a target to export documentation html to the source tree (useful when building the tarballs)
	add_custom_target (documentation
		COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_BINARY_DIR}/docbuild/AppStream-Docs/en-US/html/" "${DOC_HTML_EXPORT_DIR}"
		DEPENDS documentation-noexport
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)
	add_custom_command(
		TARGET documentation POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}/api/html" "${CMAKE_CURRENT_SOURCE_DIR}/html/api/html"
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)

	#########################
	# API documentation

	find_package(GtkDoc)
	if(NOT GTKDOC_FOUND)
		message(FATAL_ERROR "gtkdoc was not found, API documentation can not be built.")
	endif()
	include(UseGtkDoc)

	gtk_doc_add_module(appstream ${CMAKE_SOURCE_DIR}/src
		IGNOREHEADERS as-component-private.h as-utils.h as-database-write.h as-settings-private.h
		SUFFIXES h c hh cc
		LDFLAGS
			-L${CMAKE_CURRENT_BINARY_DIR}/../src
			-lappstream
		LDPATH
			"${CMAKE_CURRENT_BINARY_DIR}/../src"
		OUTPUT_DIR
			"${CMAKE_CURRENT_SOURCE_DIR}/api"
		DEPENDS appstream)

	set_directory_properties (PROPERTIES CLEAN_NO_CUSTOM ${CMAKE_CURRENT_SOURCE_DIR}/api)
 	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/api/html;${CMAKE_CURRENT_SOURCE_DIR}/api/xml;${CMAKE_CURRENT_SOURCE_DIR}/api/tmpl")
endif()

option(INSTALL_PREBUILT_DOCS "Install prebuilt documentation, if found" ON)
if (INSTALL_PREBUILT_DOCS OR DOCUMENTATION)
	if (DOCUMENTATION OR (EXISTS "${DOC_HTML_EXPORT_DIR}" AND IS_DIRECTORY "${DOC_HTML_EXPORT_DIR}"))
		install(DIRECTORY "${DOC_HTML_EXPORT_DIR}/" DESTINATION ${CMAKE_INSTALL_DATADIR}/doc/appstream/html)

		install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/gtk-doc/html/)
		install(CODE "if (\"\$ENV{DESTDIR}\" STREQUAL \"\")
					execute_process (COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
						${CMAKE_INSTALL_FULL_DATADIR}/doc/appstream/html/api/html/
						${CMAKE_INSTALL_FULL_DATADIR}/gtk-doc/html/appstream
					)
				else ()
					execute_process (COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
						${CMAKE_INSTALL_FULL_DATADIR}/doc/appstream/html/api/html/
						\$ENV{DESTDIR}/${CMAKE_INSTALL_FULL_DATADIR}/gtk-doc/html/appstream
					)
				endif ()")
	endif()
endif()

=== qt/CMakeLists.txt ===
project(AppstreamQt)
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

include(CMakePackageConfigHelpers)
include(GenerateExportHeader)
add_compiler_export_flags()

find_package(Xapian 1.2 REQUIRED)

ENABLE_TESTING()

if(${AS_VERSION} STREQUAL "")
    set(AS_VERSION "0.8.4")
endif()

find_package(Qt5 REQUIRED COMPONENTS Core)

set(APPSTREAMQT_SO_VERSION 1)
set(APPSTREAMQT_VERSION ${AS_VERSION})

set(CMAKE_AUTOMOC on)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INCLUDE_CURRENT_DIR_IN_INTERFACE ON)
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# Paths
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX
    "/usr" CACHE PATH "Default install prefix" FORCE)
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

# Special case for /etc and /var when prefix is /usr
if(${CMAKE_INSTALL_PREFIX} STREQUAL "/usr")
  set(CMAKE_INSTALL_SYSCONFDIR "/etc" CACHE PATH "read-only single-machine data (etc)")
  set(CMAKE_INSTALL_LOCALSTATEDIR "/var" CACHE PATH "modifiable single-machine data (var)")
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/usr")
include(GNUInstallDirs)

add_subdirectory(src)

=== src/CMakeLists.txt ===
# CMakeLists for AppStream database shared lib

find_package(GLIB2 2.36 REQUIRED)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_package(Xapian 1.2 REQUIRED)
find_package(GI REQUIRED)
find_package(LibXml2 REQUIRED)
find_library(M_LIB m)

include(GObjectIntrospectionMacros)
set(INTROSPECTION_GIRS)
set(INTROSPECTION_SCANNER_ARGS "--identifier-prefix=As" "--symbol-prefix=as" "--warn-all" "--add-include-path=${CMAKE_CURRENT_SOURCE_DIR}")
set(INTROSPECTION_COMPILER_ARGS "--includedir=${CMAKE_CURRENT_SOURCE_DIR}")

set (srcdir ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "Source dir")
set(AS_VERSION_BASE "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}" CACHE INTERNAL "LibAppStream combined version number")

set(ASLIB_XAP_SOURCES xapian/database-common.hpp
		xapian/database-read.hpp
		xapian/database-read.cpp
		xapian/database-write.hpp
		xapian/database-write.cpp
		xapian/database-cwrap.hpp
		xapian/database-cwrap.cpp
)

set(LIBAPPSTREAM_SRC
		as-utils.c
		# internal stuff to build the database
		as-cache-builder.c
		# (mostly) public API
		as-metadata.c
		as-component.c
		as-enums.c
		as-provides.c
		as-data-pool.c
		as-search-query.c
		as-database.c
		as-category.c
		as-menu-parser.c
		as-distro-details.c
		as-screenshot.c
		as-image.c
		as-release.c
		as-validator.c
		as-validator-issue.c
)

set(LIBAPPSTREAM_PUBLIC_HEADERS
		appstream.h
		as-utils.h
		as-metadata.h
		as-component.h
		as-data-pool.h
		as-enums.h
		as-provides.h
		as-search-query.h
		as-database.h
		as-category.h
		as-menu-parser.h
		as-distro-details.h
		as-screenshot.h
		as-image.h
		as-release.h
		as-validator.h
		as-validator-issue.h
)

set(LIBAPPSTREAM_PRIVATE_HEADERS
		as-utils-private.h
		as-metadata-private.h
		as-component-private.h
		as-cache-builder.h
)

# find stuff necessary to build libappstream with DEP-11 support
if(DEBIAN_DEP11)
	pkg_check_modules(YAML REQUIRED yaml-0.1)
	set(LIBAPPSTREAM_SRC ${LIBAPPSTREAM_SRC} as-dep11.c)
	set(LIBAPPSTREAM_PRIVATE_HEADERS ${LIBAPPSTREAM_PRIVATE_HEADERS} as-dep11.h)
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/xapian
		    ${CMAKE_BINARY_DIR}
		    ${CMAKE_BINARY_DIR}/src
		    ${GLIB2_INCLUDE_DIR}
		    ${GIO2_INCLUDE_DIR}
		    ${LIBXML2_INCLUDE_DIR}
		    ${XAPIAN_INCLUDE_DIR}
		    ${YAML_INCLUDE_DIR}
)

add_definitions("-DAS_COMPILATION")

# ensure that the GI compiler has been found (apparently, the automatic tests fail on some machines)
if (INTROSPECTION_COMPILER STREQUAL "")
  message(FATAL_ERROR "GObject-Introspection was not found! Please install it to continue.")
endif()

add_library(appstream SHARED ${ASLIB_XAP_SOURCES} ${LIBAPPSTREAM_SRC} ${LIBAPPSTREAM_PUBLIC_HEADERS} ${LIBAPPSTREAM_PRIVATE_HEADERS})
set_target_properties(appstream PROPERTIES VERSION ${AS_VERSION} SOVERSION ${APPSTREAM_LIB_API_LEVEL})

target_link_libraries(appstream
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		${LIBXML2_LIBRARIES}
		${XAPIAN_LIBRARIES}
		${YAML_LIBRARIES}
)

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/appstream.pc.in ${CMAKE_CURRENT_BINARY_DIR}/appstream.pc @ONLY)

####
# GObject Introspection
macro(_list_prefix _outvar _listvar _prefix)
  set(${_outvar})
  foreach(_item IN LISTS ${_listvar})
    list(APPEND ${_outvar} ${_prefix}${_item})
  endforeach()
endmacro(_list_prefix)

set(introspection_files ${LIBAPPSTREAM_SRC} ${LIBAPPSTREAM_PUBLIC_HEADERS})
set(AppStream_0_8_gir "appstream")
set(AppStream_0_8_gir_INCLUDES GObject-2.0 Gio-2.0)
set(AppStream_0_8_gir_CFLAGS "-I${CMAKE_CURRENT_SOURCE_DIR}/" "-DAS_COMPILATION")
set(AppStream_0_8_gir_LIBS appstream)

_list_prefix(AppStream_0_8_gir_FILES introspection_files "${CMAKE_CURRENT_SOURCE_DIR}/")
set(AppStream_0_8_gir_SCANNERFLAGS --c-include appstream.h)
set(AppStream_0_8_gir_EXPORT_PACKAGES appstream)

list(APPEND INTROSPECTION_GIRS AppStream-0.8.gir)
gir_add_introspections(INTROSPECTION_GIRS)
####

install(TARGETS appstream DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${LIBAPPSTREAM_PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/AppStream)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appstream.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/)

=== tests/CMakeLists.txt ===
# CMakeLists for UAI Unit Tests

find_package(GLIB2 REQUIRED)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_package(LibXml2 REQUIRED)
find_library(M_LIB m)

link_libraries(${M_LIB}
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		${LIBXML2_LIBRARIES}
		appstream
)

include_directories(${CMAKE_BINARY_DIR}
		${CMAKE_SOURCE_DIR}/src
		${CMAKE_SOURCE_DIR}/src/xapian
		${CMAKE_CURRENT_SOURCE_DIR}
		${GLIB2_INCLUDE_DIR}
		${GIO2_INCLUDE_DIR}
		${LIBXML2_INCLUDE_DIR}
)

# Basic tests
add_executable(as-test-basics test-basics.c)
add_dependencies(as-test-basics appstream)
add_test(basic-test as-test-basics ${CMAKE_CURRENT_SOURCE_DIR})

# AppStream XML parser tests
add_executable(as-test-asxml test-asxml.c)
add_dependencies(as-test-asxml appstream)
add_test(asxml-test as-test-asxml ${CMAKE_CURRENT_SOURCE_DIR})

if(DEBIAN_DEP11)
# AppStream DEP-11 parser tests
add_executable(as-test-dep11 test-dep11.c)
add_dependencies(as-test-dep11 appstream)
add_test(dep11-test as-test-dep11 ${CMAKE_CURRENT_SOURCE_DIR})
endif()

# AppStream database tests
add_executable(as-test-database test-database.c)
add_dependencies(as-test-database appstream)
add_test(database-test as-test-database ${CMAKE_CURRENT_SOURCE_DIR})

=== tools/CMakeLists.txt ===
# CMakeLists for the AppStream CLI tool
project(appstream-cli)

find_package(GLIB2 REQUIRED)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_library(M_LIB m)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
		    ${CMAKE_BINARY_DIR}
		    ${CMAKE_SOURCE_DIR}/src
		    ${GLIB2_INCLUDE_DIR}
		    ${GIO2_INCLUDE_DIR}
)

set(ASCLI_SOURCES
	appstream-cli.c
	ascli-utils.h
	ascli-utils.c
	ascli-mdata-actions.h
	ascli-mdata-actions.c
	ascli-validate-actions.h
	ascli-validate-actions.c
)

# Add the appstream client tool
add_executable(appstreamcli ${ASCLI_SOURCES})
add_dependencies(appstreamcli appstream)

# the client tool uses API which is currently private...
# needs to be sorted out in future
add_definitions ("-DAS_COMPILATION")

target_link_libraries(appstreamcli
		${M_LIB}
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		appstream
)

install(TARGETS appstreamcli DESTINATION ${CMAKE_INSTALL_BINDIR})

=== contrib/vapi/CMakeLists.txt ===
# Vala API

set(APPSTREAM_VAPI_FILE "${CMAKE_CURRENT_BINARY_DIR}/appstream.vapi")

find_program (VAPIGEN vapigen)
mark_as_advanced (VAPIGEN)
if (VAPIGEN STREQUAL "VAPIGEN-NOTFOUND")
	message (FATAL_ERROR "Vapigen was not found. Please install it in order to generate Vala API files!")
endif (VAPIGEN STREQUAL "VAPIGEN-NOTFOUND")

add_custom_command (OUTPUT ${APPSTREAM_VAPI_FILE}
			COMMAND ${VAPIGEN} --metadatadir=${CMAKE_CURRENT_SOURCE_DIR} -d . --vapidir=${CMAKE_CURRENT_SOURCE_DIR}
					${CMAKE_BINARY_DIR}/src/AppStream-${AS_VERSION_BASE}.gir
					--library=appstream
					--pkg glib-2.0 --pkg gio-2.0 --pkg gobject-2.0
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			DEPENDS appstream
					${CMAKE_BINARY_DIR}/src/Appstream-${AS_VERSION_BASE}.typelib
			VERBATIM
)
add_custom_target(vapi ALL DEPENDS ${APPSTREAM_VAPI_FILE})

install(FILES ${APPSTREAM_VAPI_FILE} DESTINATION share/vala/vapi)

=== qt/src/CMakeLists.txt ===

set(APPSTREAMQT_SRC
          component.cpp
          database.cpp
          image.cpp
          provides.cpp
          screenshot.cpp
)

set(APPSTREAMQT_PUBLIC_HEADERS
    component.h
    database.h
    image.h
    provides.h
    screenshot.h
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
		    ${CMAKE_SOURCE_DIR}/src/xapian
)

if(NOT QT)
    # hack for standalone compilation of the Qt lib (the QT variable is not defined if we build standalone)
    include_directories(${CMAKE_SOURCE_DIR}/../src/xapian)
endif()

add_library(AppstreamQt SHARED ${APPSTREAMQT_SRC})
target_link_libraries(AppstreamQt PUBLIC Qt5::Core PRIVATE ${XAPIAN_LIBRARIES})
target_include_directories(AppstreamQt PUBLIC "$<INSTALL_INTERFACE:${${CMAKE_INSTALL_INCLUDEDIR}}/>")
generate_export_header(AppstreamQt)

set_property(TARGET AppstreamQt PROPERTY VERSION "${APPSTREAMQT_VERSION}")
set_property(TARGET AppstreamQt PROPERTY SOVERSION "${APPSTREAMQT_SO_VERSION}" )

install(TARGETS AppstreamQt EXPORT AppstreamQtTargets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

install(FILES ${APPSTREAMQT_PUBLIC_HEADERS} ${CMAKE_CURRENT_BINARY_DIR}/appstreamqt_export.h DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/AppstreamQt")

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfigVersion.cmake VERSION ${APPSTREAMQT_VERSION} COMPATIBILITY SameMajorVersion )

export(TARGETS AppstreamQt
       FILE "${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtTargets.cmake")

set(ConfigPackageLocation ${CMAKE_INSTALL_LIBDIR}/cmake/AppstreamQt)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/AppstreamQtConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfig.cmake"
  @ONLY
)

install(EXPORT AppstreamQtTargets
    FILE AppstreamQtTargets.cmake
    DESTINATION ${ConfigPackageLocation})

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfigVersion.cmake ${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfig.cmake DESTINATION ${ConfigPackageLocation})

add_subdirectory(test)

=== qt/src/test/CMakeLists.txt ===

find_package(Qt5 COMPONENTS Test REQUIRED)

add_executable(screenshotxmlparsertest screenshotxmlparsertest.cpp)
target_link_libraries(screenshotxmlparsertest
    Qt5::Core
    Qt5::Test
    AppstreamQt
)
add_test(screenshotxmlparsertest screenshotxmlparsertest)

=== debian/changelog ===
appstream (0.8.4-1) unstable; urgency=medium

  * New upstream release: 0.8.4

 -- Matthias Klumpp <mak@debian.org>  Tue, 08 Sep 2015 20:40:36 +0200

appstream (0.8.3-2) unstable; urgency=medium

  * Bring back appstream-index package, needed for proper upgrades
  * Suggest dep11-tools

 -- Matthias Klumpp <mak@debian.org>  Sun, 30 Aug 2015 16:04:16 +0200

appstream (0.8.3-1) unstable; urgency=medium

  * New upstream release: 0.8.3

 -- Matthias Klumpp <mak@debian.org>  Fri, 28 Aug 2015 22:42:11 +0200

appstream (0.8.2-2) unstable; urgency=medium

  * Include changelog file
  * Fix debian/copyright
  * Rename appstream-index package to appstream

 -- Matthias Klumpp <mak@debian.org>  Tue, 25 Aug 2015 22:24:08 +0200

=== debian/control ===
Source: appstream
Section: admin
Priority: optional
Maintainer: Matthias Klumpp <mak@debian.org>
Build-Depends: cmake (>= 2.8),
               debhelper (>= 9.0.0),
               gtk-doc-tools,
               intltool,
               libdbus-glib-1-dev,
               libgirepository1.0-dev (>= 1.32),
               libglib2.0-dev (>= 2.40),
               libxapian-dev (>= 1.2.12),
               libxml2-dev (>= 2.8.0),
               libyaml-dev,
               qtbase5-dev,
               xmlto
Standards-Version: 3.9.6
Homepage: http://www.freedesktop.org/wiki/Distributions/AppStream/
Vcs-Git: git://anonscm.debian.org/pkg-packagekit/appstream.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-packagekit/appstream.git

Package: appstream
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: appstream-index (<< ${source:Version})
Provides: appstream-index
Suggests: dep11-tools
Description: Software component index
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format,
 screenshot services and various other things needed to make handling
 of software smarter. Also, the AppStream data allows building
 application-centric software management tools.
 .
 This package provides tools to generate, maintain and access the
 AppStream database of installed and available software.

Package: libappstream2
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: appstream (>= ${binary:Version})
Description: Library to access AppStream services
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format
 and various other things needed to make handling of software smarter.
 .
 This package contains a GObject-based library to access AppStream
 services, like the software component metadata database.
 It also contains functions for working with AppStream XML metadata.

Package: libappstream-dev
Architecture: any
Section: libdevel
Depends: libappstream2 (= ${binary:Version}),
         libglib2.0-dev (>= 2.40),
         ${misc:Depends}
Description: Library to access AppStream services (development files)
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format
 and various other things needed to make handling of software smarter.
 .
 This package contains development files necessary to develop
 software-management tools which use the AppStream library.

Package: gir1.2-appstream
Architecture: any
Section: introspection
Depends: gir1.2-freedesktop (>= 1.32),
         gir1.2-glib-2.0 (>= 1.40),
         libappstream2 (= ${binary:Version}),
         ${misc:Depends}
Description: Library to access AppStream services (introspection data)
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format
 and various other things needed to make handling of software smarter.
 .
 This package contains introspection data for the AppStream library.

Package: libappstreamqt1
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: appstream (>= ${binary:Version})
Description: Qt5 library to access AppStream services
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format
 and various other things needed to make handling of software smarter.
 .
 This package contains a Qt-based library to access AppStream
 services, like the software component metadata database.

Package: libappstreamqt-dev
Architecture: any
Section: libdevel
Depends: libappstreamqt1 (= ${binary:Version}),
         qtbase5-dev,
         ${misc:Depends}
Description: Qt5 library to access AppStream services (development files)
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format
 and various other things needed to make handling of software smarter.
 .
 This package contains development files necessary to develop
 software-management tools which use the Qt5-based AppStream library.

Package: appstream-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: appstream
Description: Developer documentation for AppStream
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format
 and various other things needed to make handling of software smarter.
 .
 This package provides developer documentation for AppStream.

Package: appstream-index
Architecture: all
Section: oldlibs
Priority: extra
Depends: appstream (>= ${source:Version}),
         ${misc:Depends}
Description: Transitional package (appstream-index -> appstream)
 Transitional dummy package replacing appstream-index with
 appstream.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

AS_CONFIGURE_ARGS = -DTESTS=ON \
		-DQT=ON \
		-DDEBIAN_DEP11=ON


# Define install target dir
INSTALLDIR = $(CURDIR)/debian/tmp

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(AS_CONFIGURE_ARGS)

override_dh_auto_install:
	dh_auto_install --destdir=$(INSTALLDIR)

override_dh_install:
	dh_install --list-missing
